Loading...
Searching...
No Matches
elastix::ElastixTemplate< TFixedImage, TMovingImage > Class Template Referencefinal
Core » Kernel

`#include <elxElastixTemplate.h>`

## Detailed Description

template<class TFixedImage, class TMovingImage>
class elastix::ElastixTemplate< TFixedImage, TMovingImage >

The main elastix class, which connects components and invokes the BeforeRegistration(), BeforeEachResolution(), etc. methods.

The ElastixTemplate class ...

Parameters

  WriteTransformParametersEachIteration: Controls whether to save a transform parameter file to disk in every iteration.
  example: (WriteTransformParametersEachIteration "true")
  This parameter can not be specified for each resolution separately. Default value: "false".

  WriteTransformParametersEachResolution: Controls whether to save a transform parameter file to disk in every resolution.
  example: (WriteTransformParametersEachResolution "true")
  This parameter can not be specified for each resolution separately. Default value: "false".

  UseDirectionCosines: Controls whether to use or ignore the direction cosines (world matrix, transform matrix) set in the images. Voxel spacing and image origin are always taken into account, regardless the setting of this parameter.
  example: (UseDirectionCosines "true")
  Default: true. Recommended: true. This parameter was introduced in elastix 4.3, with a default value of false for backward compabitility. From elastix 4.8 the default value has been changed to true. Setting it to false means that you choose to ignore important information from the image, which relates voxel coordinates to world coordinates. Ignoring it may easily lead to left/right swaps for example, which could skrew up a (medical) analysis.

Definition at line 103 of file elxElastixTemplate.h.

Inheritance diagram for elastix::ElastixTemplate< TFixedImage, TMovingImage >:
[legend]

## Public Types

using | AfterEachIterationCommandPointer = typename AfterEachIterationCommandType::Pointer
using | AfterEachIterationCommandType = itk::SimpleMemberCommand<Self>
using | AfterEachResolutionCommandPointer = typename AfterEachResolutionCommandType::Pointer
using | AfterEachResolutionCommandType = itk::SimpleMemberCommand<Self>
using | BaseComponentType = BaseComponent
using | BeforeEachResolutionCommandPointer = typename BeforeEachResolutionCommandType::Pointer
using | BeforeEachResolutionCommandType = itk::SimpleMemberCommand<Self>
using | ConstPointer = itk::SmartPointer<const Self>
using | FixedImageDirectionType = typename FixedImageType::DirectionType
using | FixedImagePointer = typename FixedImageType::Pointer
using | FixedImagePyramidBaseType = FixedImagePyramidBase<Self>
using | FixedImageType = TFixedImage
using | FixedMaskPointer = typename FixedMaskType::Pointer
using | FixedMaskType = itk::Image<MaskPixelType, FixedDimension>
using | ImageSamplerBaseType = elx::ImageSamplerBase<Self>
using | InputImageType = MovingImageType
using | InterpolatorBaseType = InterpolatorBase<Self>
using | MaskPixelType = unsigned char
using | MetricBaseType = MetricBase<Self>
using | MovingImagePointer = typename MovingImageType::Pointer
using | MovingImagePyramidBaseType = MovingImagePyramidBase<Self>
using | MovingImageType = TMovingImage
using | MovingMaskPointer = typename MovingMaskType::Pointer
using | MovingMaskType = itk::Image<MaskPixelType, MovingDimension>
using | OptimizerBaseType = OptimizerBase<Self>
using | OutputImageType = MovingImageType
using | ParameterMapType = itk::ParameterMapInterface::ParameterMapType
using | Pointer = itk::SmartPointer<Self>
using | PtrToMemberFunction = void (BaseComponentType::*)()
using | PtrToMemberFunction2 = int (BaseComponentType::*)()
using | RegistrationBaseType = RegistrationBase<Self>
using | ResampleInterpolatorBaseType = ResampleInterpolatorBase<Self>
using | ResamplerBaseType = ResamplerBase<Self>
using | Self = ElastixTemplate
using | Superclass = ElastixBase
using | TransformBaseType = elx::TransformBase<Self>
Public Types inherited from elastix::ElastixBase
using | ComponentDatabasePointer = ComponentDatabase::Pointer
using | CoordRepType = double
using | DataObjectContainerPointer = DataObjectContainerType::Pointer
using | DataObjectContainerType = itk::VectorContainer<unsigned int, DataObjectPointer>
using | DataObjectPointer = itk::DataObject::Pointer
using | DBIndexType = ComponentDatabase::IndexType
using | FileNameContainerPointer = FileNameContainerType::Pointer
using | FileNameContainerType = itk::VectorContainer<unsigned int, std::string>
using | FlatDirectionCosinesType = std::vector<double>
using | ObjectContainerPointer = ObjectContainerType::Pointer
using | ObjectContainerType = itk::VectorContainer<unsigned int, ObjectPointer>
using | ObjectPointer = itk::Object::Pointer
using | ParameterMapType = itk::ParameterMapInterface::ParameterMapType
using | ResultDeformationFieldType = itk::DataObject
using | ResultImageType = itk::DataObject
using | Self = ElastixBase
using | Superclass = BaseComponent

## Public Member Functions

void | AfterEachIteration () override
void | AfterEachResolution () override
void | AfterRegistration () override
int | ApplyTransform (bool doReadTransform) override
int | BeforeAll () override
int | BeforeAllTransformix ()
void | BeforeEachResolution () override
void | BeforeRegistration () override
| elxGetBaseMacro (FixedImagePyramid, FixedImagePyramidBaseType)
| elxGetBaseMacro (ImageSampler, ImageSamplerBaseType)
| elxGetBaseMacro (Interpolator, InterpolatorBaseType)
| elxGetBaseMacro (Metric, MetricBaseType)
| elxGetBaseMacro (MovingImagePyramid, MovingImagePyramidBaseType)
| elxGetBaseMacro (Optimizer, OptimizerBaseType)
| elxGetBaseMacro (Registration, RegistrationBaseType)
| elxGetBaseMacro (ResampleInterpolator, ResampleInterpolatorBaseType)
| elxGetBaseMacro (Resampler, ResamplerBaseType)
| elxGetBaseMacro (Transform, TransformBaseType)
virtual const char * | GetClassName () const
virtual const char * | GetCurrentTransformParameterFileName () const
FixedImageType * | GetFixedImage (unsigned int idx=0) const
FixedMaskType * | GetFixedMask (unsigned int idx=0) const
virtual unsigned int | GetIterationCounter () const
MovingImageType * | GetMovingImage (unsigned int idx=0) const
MovingMaskType * | GetMovingMask (unsigned int idx=0) const
bool | GetOriginalFixedImageDirection (FixedImageDirectionType &direction) const
| ITK_DISALLOW_COPY_AND_MOVE (ElastixTemplate)
| itkStaticConstMacro (Dimension, unsigned int, FixedImageType::ImageDimension)
| itkStaticConstMacro (FixedDimension, unsigned int, FixedImageType::ImageDimension)
| itkStaticConstMacro (MovingDimension, unsigned int, MovingImageType::ImageDimension)
int | Run () override
Public Member Functions inherited from elastix::ElastixBase
void | AddTargetCellToIterationInfo (const char *const name)
int | BeforeAllBase () override
int | BeforeAllTransformixBase ()
| elxGetNumberOfMacro (FixedImage)
| elxGetNumberOfMacro (FixedImageFileName)
| elxGetNumberOfMacro (FixedImagePyramid)
| elxGetNumberOfMacro (FixedMask)
| elxGetNumberOfMacro (FixedMaskFileName)
| elxGetNumberOfMacro (ImageSampler)
| elxGetNumberOfMacro (Interpolator)
| elxGetNumberOfMacro (Metric)
| elxGetNumberOfMacro (MovingImage)
| elxGetNumberOfMacro (MovingImageFileName)
| elxGetNumberOfMacro (MovingImagePyramid)
| elxGetNumberOfMacro (MovingMask)
| elxGetNumberOfMacro (MovingMaskFileName)
| elxGetNumberOfMacro (Optimizer)
| elxGetNumberOfMacro (Registration)
| elxGetNumberOfMacro (ResampleInterpolator)
| elxGetNumberOfMacro (Resampler)
| elxGetNumberOfMacro (ResultDeformationField)
| elxGetNumberOfMacro (ResultImage)
| elxGetNumberOfMacro (Transform)
| elxGetObjectMacro (Configuration, Configuration)
| elxGetObjectMacro (FinalTransform, itk::Object)
| elxGetObjectMacro (FixedImageContainer, DataObjectContainerType)
| elxGetObjectMacro (FixedImageFileNameContainer, FileNameContainerType)
| elxGetObjectMacro (FixedImagePyramidContainer, ObjectContainerType)
| elxGetObjectMacro (FixedMaskContainer, DataObjectContainerType)
| elxGetObjectMacro (FixedMaskFileNameContainer, FileNameContainerType)
| elxGetObjectMacro (ImageSamplerContainer, ObjectContainerType)
| elxGetObjectMacro (InitialTransform, itk::Object)
| elxGetObjectMacro (InterpolatorContainer, ObjectContainerType)
| elxGetObjectMacro (MetricContainer, ObjectContainerType)
| elxGetObjectMacro (MovingImageContainer, DataObjectContainerType)
| elxGetObjectMacro (MovingImageFileNameContainer, FileNameContainerType)
| elxGetObjectMacro (MovingImagePyramidContainer, ObjectContainerType)
| elxGetObjectMacro (MovingMaskContainer, DataObjectContainerType)
| elxGetObjectMacro (MovingMaskFileNameContainer, FileNameContainerType)
| elxGetObjectMacro (OptimizerContainer, ObjectContainerType)
| elxGetObjectMacro (RegistrationContainer, ObjectContainerType)
| elxGetObjectMacro (ResampleInterpolatorContainer, ObjectContainerType)
| elxGetObjectMacro (ResamplerContainer, ObjectContainerType)
| elxGetObjectMacro (ResultDeformationFieldContainer, DataObjectContainerType)
| elxGetObjectMacro (ResultImageContainer, DataObjectContainerType)
| elxGetObjectMacro (TransformContainer, ObjectContainerType)
| elxSetObjectMacro (Configuration, Configuration)
| elxSetObjectMacro (FinalTransform, itk::Object)
| elxSetObjectMacro (FixedImageContainer, DataObjectContainerType)
| elxSetObjectMacro (FixedImageFileNameContainer, FileNameContainerType)
| elxSetObjectMacro (FixedImagePyramidContainer, ObjectContainerType)
| elxSetObjectMacro (FixedMaskContainer, DataObjectContainerType)
| elxSetObjectMacro (FixedMaskFileNameContainer, FileNameContainerType)
| elxSetObjectMacro (ImageSamplerContainer, ObjectContainerType)
| elxSetObjectMacro (InitialTransform, itk::Object)
| elxSetObjectMacro (InterpolatorContainer, ObjectContainerType)
| elxSetObjectMacro (MetricContainer, ObjectContainerType)
| elxSetObjectMacro (MovingImageContainer, DataObjectContainerType)
| elxSetObjectMacro (MovingImageFileNameContainer, FileNameContainerType)
| elxSetObjectMacro (MovingImagePyramidContainer, ObjectContainerType)
| elxSetObjectMacro (MovingMaskContainer, DataObjectContainerType)
| elxSetObjectMacro (MovingMaskFileNameContainer, FileNameContainerType)
| elxSetObjectMacro (OptimizerContainer, ObjectContainerType)
| elxSetObjectMacro (RegistrationContainer, ObjectContainerType)
| elxSetObjectMacro (ResampleInterpolatorContainer, ObjectContainerType)
| elxSetObjectMacro (ResamplerContainer, ObjectContainerType)
| elxSetObjectMacro (ResultDeformationFieldContainer, DataObjectContainerType)
| elxSetObjectMacro (ResultImageContainer, DataObjectContainerType)
| elxSetObjectMacro (TransformContainer, ObjectContainerType)
DBIndexType | GetDBIndex ()
IterationInfo & | GetIterationInfo ()
std::ostream & | GetIterationInfoAt (const char *const name)
vcl_size_t | GetNumberOfTransformConfigurations () const
const FlatDirectionCosinesType & | GetOriginalFixedImageDirectionFlat () const
Configuration::ConstPointer | GetPreviousTransformConfiguration (const Configuration &configuration) const
ResultDeformationFieldType * | GetResultDeformationField (unsigned int idx=0) const
ResultImageType * | GetResultImage (const unsigned int idx=0) const
Configuration::ConstPointer | GetTransformConfiguration (const vcl_size_t index) const
ParameterMapType | GetTransformParameterMap () const
bool | GetUseDirectionCosines () const
| ITK_DISALLOW_COPY_AND_MOVE (ElastixBase)
void | SetDBIndex (DBIndexType _arg)
void | SetOriginalFixedImageDirectionFlat (const FlatDirectionCosinesType &arg)
void | SetResultDeformationField (DataObjectPointer result_deformationfield)
void | SetResultImage (DataObjectPointer result_image)
void | SetTransformConfigurations (const std::vector< Configuration::ConstPointer > &configurations)
Public Member Functions inherited from elastix::BaseComponent
virtual void | AfterEachIterationBase ()
virtual void | AfterEachResolutionBase ()
virtual void | AfterRegistrationBase ()
virtual void | BeforeEachResolutionBase ()
virtual void | BeforeRegistrationBase ()
virtual const char * | elxGetClassName () const
const char * | GetComponentLabel () const
| ITK_DISALLOW_COPY_AND_MOVE (BaseComponent)
| itkTypeMacroNoParent (BaseComponent)
void | SetComponentLabel (const char *label, unsigned int idx)

## Static Public Member Functions

static Pointer | New ()
Static Public Member Functions inherited from elastix::BaseComponent
template<typename TBaseComponent>
static auto | AsITKBaseType (TBaseComponent *const baseComponent) -> decltype(baseComponent->GetAsITKBaseType())
static void | InitializeElastixExecutable ()
static bool | IsElastixLibrary ()

## Private Member Functions

void | CallInEachComponent (PtrToMemberFunction func)
int | CallInEachComponentInt (PtrToMemberFunction2 func)
void | ConfigureComponents (Self *This)
void | CreateTransformParameterFile (const std::string &FileName, const bool ToLog)
void | CreateTransformParameterMap () override
| ElastixTemplate ()=default
void | OpenIterationInfoFile ()
void | SetOriginalFixedImageDirection (const FixedImageDirectionType &arg)
| ~ElastixTemplate () override=default

## Private Attributes

AfterEachIterationCommandPointer | m_AfterEachIterationCommand {}
AfterEachResolutionCommandPointer | m_AfterEachResolutionCommand {}
BeforeEachResolutionCommandPointer | m_BeforeEachResolutionCommand {}

## Additional Inherited Members

Protected Member Functions inherited from elastix::ElastixBase
| ElastixBase ()
| ~ElastixBase () override=default
Protected Member Functions inherited from elastix::BaseComponent
| BaseComponent ()=default
virtual | ~BaseComponent ()=default
Static Protected Member Functions inherited from elastix::ElastixBase
static DataObjectContainerPointer | GenerateDataObjectContainer (DataObjectPointer dataObject)
Protected Attributes inherited from elastix::ElastixBase
std::string | m_CurrentTransformParameterFileName
DBIndexType | m_DBIndex { 0 }
unsigned int | m_IterationCounter {}
std::ofstream | m_IterationInfoFile
itk::TimeProbe | m_IterationTimer {}
FlatDirectionCosinesType | m_OriginalFixedImageDirection
itk::TimeProbe | m_ResolutionTimer {}
itk::TimeProbe | m_Timer0 {}
ParameterMapType | m_TransformParameterMap

## Member Typedef Documentation

## AfterEachIterationCommandPointer

template<class TFixedImage, class TMovingImage>

using elastix::ElastixTemplate< TFixedImage, TMovingImage >::AfterEachIterationCommandPointer = typename AfterEachIterationCommandType::Pointer

Definition at line 154 of file elxElastixTemplate.h.

## AfterEachIterationCommandType

template<class TFixedImage, class TMovingImage>

using elastix::ElastixTemplate< TFixedImage, TMovingImage >::AfterEachIterationCommandType = itk::SimpleMemberCommand<Self>

Definition at line 151 of file elxElastixTemplate.h.

## AfterEachResolutionCommandPointer

template<class TFixedImage, class TMovingImage>

using elastix::ElastixTemplate< TFixedImage, TMovingImage >::AfterEachResolutionCommandPointer = typename AfterEachResolutionCommandType::Pointer

Definition at line 153 of file elxElastixTemplate.h.

## AfterEachResolutionCommandType

template<class TFixedImage, class TMovingImage>

using elastix::ElastixTemplate< TFixedImage, TMovingImage >::AfterEachResolutionCommandType = itk::SimpleMemberCommand<Self>

Definition at line 150 of file elxElastixTemplate.h.

## BaseComponentType

template<class TFixedImage, class TMovingImage>

using elastix::ElastixTemplate< TFixedImage, TMovingImage >::BaseComponentType = BaseComponent

BaseComponent.

Definition at line 142 of file elxElastixTemplate.h.

## BeforeEachResolutionCommandPointer

template<class TFixedImage, class TMovingImage>

using elastix::ElastixTemplate< TFixedImage, TMovingImage >::BeforeEachResolutionCommandPointer = typename BeforeEachResolutionCommandType::Pointer

Definition at line 152 of file elxElastixTemplate.h.

## BeforeEachResolutionCommandType

template<class TFixedImage, class TMovingImage>

using elastix::ElastixTemplate< TFixedImage, TMovingImage >::BeforeEachResolutionCommandType = itk::SimpleMemberCommand<Self>

Commands that react on Events and call Self::Function().

Definition at line 149 of file elxElastixTemplate.h.

## ConstPointer

template<class TFixedImage, class TMovingImage>

using elastix::ElastixTemplate< TFixedImage, TMovingImage >::ConstPointer = itk::SmartPointer<const Self>

Definition at line 112 of file elxElastixTemplate.h.

## FixedImageDirectionType

template<class TFixedImage, class TMovingImage>

using elastix::ElastixTemplate< TFixedImage, TMovingImage >::FixedImageDirectionType = typename FixedImageType::DirectionType

Typedef for the UseDirectionCosines option.

Definition at line 139 of file elxElastixTemplate.h.

## FixedImagePointer

template<class TFixedImage, class TMovingImage>

using elastix::ElastixTemplate< TFixedImage, TMovingImage >::FixedImagePointer = typename FixedImageType::Pointer

Definition at line 123 of file elxElastixTemplate.h.

## FixedImagePyramidBaseType

template<class TFixedImage, class TMovingImage>

using elastix::ElastixTemplate< TFixedImage, TMovingImage >::FixedImagePyramidBaseType = FixedImagePyramidBase<Self>

The elastix basecomponent types.

Definition at line 157 of file elxElastixTemplate.h.

## FixedImageType

template<class TFixedImage, class TMovingImage>

using elastix::ElastixTemplate< TFixedImage, TMovingImage >::FixedImageType = TFixedImage

Typedef's for this class.

Definition at line 121 of file elxElastixTemplate.h.

## FixedMaskPointer

template<class TFixedImage, class TMovingImage>

using elastix::ElastixTemplate< TFixedImage, TMovingImage >::FixedMaskPointer = typename FixedMaskType::Pointer

Definition at line 135 of file elxElastixTemplate.h.

## FixedMaskType

template<class TFixedImage, class TMovingImage>

using elastix::ElastixTemplate< TFixedImage, TMovingImage >::FixedMaskType = itk::Image<MaskPixelType, FixedDimension>

Definition at line 133 of file elxElastixTemplate.h.

## ImageSamplerBaseType

template<class TFixedImage, class TMovingImage>

using elastix::ElastixTemplate< TFixedImage, TMovingImage >::ImageSamplerBaseType = elx::ImageSamplerBase<Self>

Definition at line 160 of file elxElastixTemplate.h.

## InputImageType

template<class TFixedImage, class TMovingImage>

using elastix::ElastixTemplate< TFixedImage, TMovingImage >::InputImageType = MovingImageType

Typedef's for ApplyTransform.

Todo
  How useful is this? It is not consequently supported, since the the input image is stored in the MovingImageContainer anyway.

Definition at line 172 of file elxElastixTemplate.h.

## InterpolatorBaseType

template<class TFixedImage, class TMovingImage>

using elastix::ElastixTemplate< TFixedImage, TMovingImage >::InterpolatorBaseType = InterpolatorBase<Self>

Definition at line 159 of file elxElastixTemplate.h.

## MaskPixelType

template<class TFixedImage, class TMovingImage>

using elastix::ElastixTemplate< TFixedImage, TMovingImage >::MaskPixelType = unsigned char

Types for the masks.

Definition at line 132 of file elxElastixTemplate.h.

## MetricBaseType

template<class TFixedImage, class TMovingImage>

using elastix::ElastixTemplate< TFixedImage, TMovingImage >::MetricBaseType = MetricBase<Self>

Definition at line 161 of file elxElastixTemplate.h.

## MovingImagePointer

template<class TFixedImage, class TMovingImage>

using elastix::ElastixTemplate< TFixedImage, TMovingImage >::MovingImagePointer = typename MovingImageType::Pointer

Definition at line 124 of file elxElastixTemplate.h.

## MovingImagePyramidBaseType

template<class TFixedImage, class TMovingImage>

using elastix::ElastixTemplate< TFixedImage, TMovingImage >::MovingImagePyramidBaseType = MovingImagePyramidBase<Self>

Definition at line 158 of file elxElastixTemplate.h.

## MovingImageType

template<class TFixedImage, class TMovingImage>

using elastix::ElastixTemplate< TFixedImage, TMovingImage >::MovingImageType = TMovingImage

Definition at line 122 of file elxElastixTemplate.h.

## MovingMaskPointer

template<class TFixedImage, class TMovingImage>

using elastix::ElastixTemplate< TFixedImage, TMovingImage >::MovingMaskPointer = typename MovingMaskType::Pointer

Definition at line 136 of file elxElastixTemplate.h.

## MovingMaskType

template<class TFixedImage, class TMovingImage>

using elastix::ElastixTemplate< TFixedImage, TMovingImage >::MovingMaskType = itk::Image<MaskPixelType, MovingDimension>

Definition at line 134 of file elxElastixTemplate.h.

## OptimizerBaseType

template<class TFixedImage, class TMovingImage>

using elastix::ElastixTemplate< TFixedImage, TMovingImage >::OptimizerBaseType = OptimizerBase<Self>

Definition at line 162 of file elxElastixTemplate.h.

## OutputImageType

template<class TFixedImage, class TMovingImage>

using elastix::ElastixTemplate< TFixedImage, TMovingImage >::OutputImageType = MovingImageType

Definition at line 173 of file elxElastixTemplate.h.

## ParameterMapType

template<class TFixedImage, class TMovingImage>

using elastix::ElastixTemplate< TFixedImage, TMovingImage >::ParameterMapType = itk::ParameterMapInterface::ParameterMapType

Typedef that is used in the elastix dll version.

Definition at line 176 of file elxElastixTemplate.h.

## Pointer

template<class TFixedImage, class TMovingImage>

using elastix::ElastixTemplate< TFixedImage, TMovingImage >::Pointer = itk::SmartPointer<Self>

Definition at line 111 of file elxElastixTemplate.h.

## PtrToMemberFunction

template<class TFixedImage, class TMovingImage>

using elastix::ElastixTemplate< TFixedImage, TMovingImage >::PtrToMemberFunction = void (BaseComponentType::*)()

A Pointer to a member function of a BaseComponentType.

Definition at line 145 of file elxElastixTemplate.h.

## PtrToMemberFunction2

template<class TFixedImage, class TMovingImage>

using elastix::ElastixTemplate< TFixedImage, TMovingImage >::PtrToMemberFunction2 = int (BaseComponentType::*)()

Definition at line 146 of file elxElastixTemplate.h.

## RegistrationBaseType

template<class TFixedImage, class TMovingImage>

using elastix::ElastixTemplate< TFixedImage, TMovingImage >::RegistrationBaseType = RegistrationBase<Self>

Definition at line 163 of file elxElastixTemplate.h.

## ResampleInterpolatorBaseType

template<class TFixedImage, class TMovingImage>

using elastix::ElastixTemplate< TFixedImage, TMovingImage >::ResampleInterpolatorBaseType = ResampleInterpolatorBase<Self>

Definition at line 165 of file elxElastixTemplate.h.

## ResamplerBaseType

template<class TFixedImage, class TMovingImage>

using elastix::ElastixTemplate< TFixedImage, TMovingImage >::ResamplerBaseType = ResamplerBase<Self>

Definition at line 164 of file elxElastixTemplate.h.

## Self

template<class TFixedImage, class TMovingImage>

using elastix::ElastixTemplate< TFixedImage, TMovingImage >::Self = ElastixTemplate

Standard itk.

Definition at line 109 of file elxElastixTemplate.h.

## Superclass

template<class TFixedImage, class TMovingImage>

using elastix::ElastixTemplate< TFixedImage, TMovingImage >::Superclass = ElastixBase

Definition at line 110 of file elxElastixTemplate.h.

## TransformBaseType

template<class TFixedImage, class TMovingImage>

using elastix::ElastixTemplate< TFixedImage, TMovingImage >::TransformBaseType = elx::TransformBase<Self>

Definition at line 166 of file elxElastixTemplate.h.

## Constructor & Destructor Documentation

## ElastixTemplate()

template<class TFixedImage, class TMovingImage>

elastix::ElastixTemplate< TFixedImage, TMovingImage >::ElastixTemplate | ( |  | ) |

private default

## ~ElastixTemplate()

template<class TFixedImage, class TMovingImage>

elastix::ElastixTemplate< TFixedImage, TMovingImage >::~ElastixTemplate | ( |  | ) |

override private default

## Member Function Documentation

## AfterEachIteration()

template<class TFixedImage, class TMovingImage>

void elastix::ElastixTemplate< TFixedImage, TMovingImage >::AfterEachIteration | ( |  | ) |

override virtual

Reimplemented from elastix::BaseComponent.

## AfterEachResolution()

template<class TFixedImage, class TMovingImage>

void elastix::ElastixTemplate< TFixedImage, TMovingImage >::AfterEachResolution | ( |  | ) |

override virtual

Reimplemented from elastix::BaseComponent.

## AfterRegistration()

template<class TFixedImage, class TMovingImage>

void elastix::ElastixTemplate< TFixedImage, TMovingImage >::AfterRegistration | ( |  | ) |

override virtual

Reimplemented from elastix::BaseComponent.

## ApplyTransform()

template<class TFixedImage, class TMovingImage>

int elastix::ElastixTemplate< TFixedImage, TMovingImage >::ApplyTransform | ( | bool | doReadTransform | ) |

override virtual

Implements elastix::ElastixBase.

## BeforeAll()

template<class TFixedImage, class TMovingImage>

int elastix::ElastixTemplate< TFixedImage, TMovingImage >::BeforeAll | ( |  | ) |

override virtual

The Callback functions.

Reimplemented from elastix::BaseComponent.

## BeforeAllTransformix()

template<class TFixedImage, class TMovingImage>

int elastix::ElastixTemplate< TFixedImage, TMovingImage >::BeforeAllTransformix | ( |  | ) |

## BeforeEachResolution()

template<class TFixedImage, class TMovingImage>

void elastix::ElastixTemplate< TFixedImage, TMovingImage >::BeforeEachResolution | ( |  | ) |

override virtual

Reimplemented from elastix::BaseComponent.

## BeforeRegistration()

template<class TFixedImage, class TMovingImage>

void elastix::ElastixTemplate< TFixedImage, TMovingImage >::BeforeRegistration | ( |  | ) |

override virtual

Reimplemented from elastix::BaseComponent.

## CallInEachComponent()

template<class TFixedImage, class TMovingImage>

void elastix::ElastixTemplate< TFixedImage, TMovingImage >::CallInEachComponent | ( | PtrToMemberFunction | func | ) |

private

Used by the callback functions, BeforeEachResolution() etc.). This method calls a function in each component, in the following order:

- Registration
- Transform
- ImageSampler
- Metric
- Interpolator
- Optimizer
- FixedImagePyramid
- MovingImagePyramid
- ResampleInterpolator
- Resampler

## CallInEachComponentInt()

template<class TFixedImage, class TMovingImage>

int elastix::ElastixTemplate< TFixedImage, TMovingImage >::CallInEachComponentInt | ( | PtrToMemberFunction2 | func | ) |

private

## ConfigureComponents()

template<class TFixedImage, class TMovingImage>

void elastix::ElastixTemplate< TFixedImage, TMovingImage >::ConfigureComponents | ( | Self * | This | ) |

private

Call in each component SetElastix(This) and set its ComponentLabel (for example "Metric1"). This makes sure that the component knows its own function in the registration process.

## CreateTransformParameterFile()

template<class TFixedImage, class TMovingImage>

void elastix::ElastixTemplate< TFixedImage, TMovingImage >::CreateTransformParameterFile | ( | const std::string & | FileName,
|  | const bool | ToLog )

private

CreateTransformParameterFile.

## CreateTransformParameterMap()

template<class TFixedImage, class TMovingImage>

void elastix::ElastixTemplate< TFixedImage, TMovingImage >::CreateTransformParameterMap | ( |  | ) |

override private virtual

CreateTransformParameterMap.

Implements elastix::ElastixBase.

## elxGetBaseMacro() [1/10]

template<class TFixedImage, class TMovingImage>

elastix::ElastixTemplate< TFixedImage, TMovingImage >::elxGetBaseMacro | ( | FixedImagePyramid | ,
|  | FixedImagePyramidBaseType | )

Functions to set/get pointers to the elastix components. Get the components as pointers to elxBaseType.

## elxGetBaseMacro() [2/10]

template<class TFixedImage, class TMovingImage>

elastix::ElastixTemplate< TFixedImage, TMovingImage >::elxGetBaseMacro | ( | ImageSampler | ,
|  | ImageSamplerBaseType | )

## elxGetBaseMacro() [3/10]

template<class TFixedImage, class TMovingImage>

elastix::ElastixTemplate< TFixedImage, TMovingImage >::elxGetBaseMacro | ( | Interpolator | ,
|  | InterpolatorBaseType | )

## elxGetBaseMacro() [4/10]

template<class TFixedImage, class TMovingImage>

elastix::ElastixTemplate< TFixedImage, TMovingImage >::elxGetBaseMacro | ( | Metric | ,
|  | MetricBaseType | )

## elxGetBaseMacro() [5/10]

template<class TFixedImage, class TMovingImage>

elastix::ElastixTemplate< TFixedImage, TMovingImage >::elxGetBaseMacro | ( | MovingImagePyramid | ,
|  | MovingImagePyramidBaseType | )

## elxGetBaseMacro() [6/10]

template<class TFixedImage, class TMovingImage>

elastix::ElastixTemplate< TFixedImage, TMovingImage >::elxGetBaseMacro | ( | Optimizer | ,
|  | OptimizerBaseType | )

## elxGetBaseMacro() [7/10]

template<class TFixedImage, class TMovingImage>

elastix::ElastixTemplate< TFixedImage, TMovingImage >::elxGetBaseMacro | ( | Registration | ,
|  | RegistrationBaseType | )

## elxGetBaseMacro() [8/10]

template<class TFixedImage, class TMovingImage>

elastix::ElastixTemplate< TFixedImage, TMovingImage >::elxGetBaseMacro | ( | ResampleInterpolator | ,
|  | ResampleInterpolatorBaseType | )

## elxGetBaseMacro() [9/10]

template<class TFixedImage, class TMovingImage>

elastix::ElastixTemplate< TFixedImage, TMovingImage >::elxGetBaseMacro | ( | Resampler | ,
|  | ResamplerBaseType | )

## elxGetBaseMacro() [10/10]

template<class TFixedImage, class TMovingImage>

elastix::ElastixTemplate< TFixedImage, TMovingImage >::elxGetBaseMacro | ( | Transform | ,
|  | TransformBaseType | )

## GetClassName()

template<class TFixedImage, class TMovingImage>

virtual const char * elastix::ElastixTemplate< TFixedImage, TMovingImage >::GetClassName | ( |  | ) | const

virtual

Run-time type information (and related methods).

## GetCurrentTransformParameterFileName()

template<class TFixedImage, class TMovingImage>

virtual const char * elastix::ElastixTemplate< TFixedImage, TMovingImage >::GetCurrentTransformParameterFileName | ( |  | ) | const

virtual

Get the name of the current transform parameter file.

## GetFixedImage()

template<class TFixedImage, class TMovingImage>

FixedImageType * elastix::ElastixTemplate< TFixedImage, TMovingImage >::GetFixedImage | ( | unsigned int | idx = 0 | ) | const

Get pointers to the images. They are obtained from the {Fixed,Moving}ImageContainer and casted to the appropriate type.

## GetFixedMask()

template<class TFixedImage, class TMovingImage>

FixedMaskType * elastix::ElastixTemplate< TFixedImage, TMovingImage >::GetFixedMask | ( | unsigned int | idx = 0 | ) | const

Get pointers to the masks. They are obtained from the {Fixed,Moving}MaskContainer and casted to the appropriate type.

## GetIterationCounter()

template<class TFixedImage, class TMovingImage>

virtual unsigned int elastix::ElastixTemplate< TFixedImage, TMovingImage >::GetIterationCounter | ( |  | ) | const

virtual

Get the iteration number.

## GetMovingImage()

template<class TFixedImage, class TMovingImage>

MovingImageType * elastix::ElastixTemplate< TFixedImage, TMovingImage >::GetMovingImage | ( | unsigned int | idx = 0 | ) | const

## GetMovingMask()

template<class TFixedImage, class TMovingImage>

MovingMaskType * elastix::ElastixTemplate< TFixedImage, TMovingImage >::GetMovingMask | ( | unsigned int | idx = 0 | ) | const

## GetOriginalFixedImageDirection()

template<class TFixedImage, class TMovingImage>

bool elastix::ElastixTemplate< TFixedImage, TMovingImage >::GetOriginalFixedImageDirection | ( | FixedImageDirectionType & | direction | ) | const

Get the original direction cosines of the fixed image. Returns false if it failed to determine the original fixed image direction. In that case the direction var is left unchanged. If no fixed image is present, it tries to read it from the parameter file.

## ITK_DISALLOW_COPY_AND_MOVE()

template<class TFixedImage, class TMovingImage>

elastix::ElastixTemplate< TFixedImage, TMovingImage >::ITK_DISALLOW_COPY_AND_MOVE | ( | ElastixTemplate< TFixedImage, TMovingImage > |  | ) |

## itkStaticConstMacro() [1/3]

template<class TFixedImage, class TMovingImage>

elastix::ElastixTemplate< TFixedImage, TMovingImage >::itkStaticConstMacro | ( | Dimension | ,
|  | unsigned int | ,
|  | FixedImageType::ImageDimension | )

For using the Dimensions.

## itkStaticConstMacro() [2/3]

template<class TFixedImage, class TMovingImage>

elastix::ElastixTemplate< TFixedImage, TMovingImage >::itkStaticConstMacro | ( | FixedDimension | ,
|  | unsigned int | ,
|  | FixedImageType::ImageDimension | )

## itkStaticConstMacro() [3/3]

template<class TFixedImage, class TMovingImage>

elastix::ElastixTemplate< TFixedImage, TMovingImage >::itkStaticConstMacro | ( | MovingDimension | ,
|  | unsigned int | ,
|  | MovingImageType::ImageDimension | )

## New()

template<class TFixedImage, class TMovingImage>

Pointer elastix::ElastixTemplate< TFixedImage, TMovingImage >::New | ( |  | ) |

static

Method for creation through the object factory.

## OpenIterationInfoFile()

template<class TFixedImage, class TMovingImage>

void elastix::ElastixTemplate< TFixedImage, TMovingImage >::OpenIterationInfoFile | ( |  | ) |

private

Open the IterationInfoFile, where the table with iteration info is written to.

## Run()

template<class TFixedImage, class TMovingImage>

int elastix::ElastixTemplate< TFixedImage, TMovingImage >::Run | ( |  | ) |

override virtual

Main functions: Run() for registration, and ApplyTransform() for just applying a transform to an image.

Implements elastix::ElastixBase.

## SetOriginalFixedImageDirection()

template<class TFixedImage, class TMovingImage>

void elastix::ElastixTemplate< TFixedImage, TMovingImage >::SetOriginalFixedImageDirection | ( | const FixedImageDirectionType & | arg | ) |

private

Set the direction in the superclass' m_OriginalFixedImageDirection variable

## Field Documentation

## m_AfterEachIterationCommand

template<class TFixedImage, class TMovingImage>

AfterEachIterationCommandPointer elastix::ElastixTemplate< TFixedImage, TMovingImage >::m_AfterEachIterationCommand {}

private

Definition at line 263 of file elxElastixTemplate.h.

## m_AfterEachResolutionCommand

template<class TFixedImage, class TMovingImage>

AfterEachResolutionCommandPointer elastix::ElastixTemplate< TFixedImage, TMovingImage >::m_AfterEachResolutionCommand {}

private

Definition at line 264 of file elxElastixTemplate.h.

## m_BeforeEachResolutionCommand

template<class TFixedImage, class TMovingImage>

BeforeEachResolutionCommandPointer elastix::ElastixTemplate< TFixedImage, TMovingImage >::m_BeforeEachResolutionCommand {}

private

CallBack commands.

Definition at line 262 of file elxElastixTemplate.h.

Generated on 1768596610 for elastix by 1.15.0 |